using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;

using notes.Core;

namespace notes.Android.Adapters
{
    public class NoteListAdapter : BaseAdapter<Note>
    {
		protected Activity context = null;
		protected IList<Note> notes = new List<Note>();
		
		public NoteListAdapter (Activity context, IList<Note> Notes) : base ()
		{
			this.context = context;
			this.notes = Notes;
		}
		
		public override Note this[int position]
		{
			get { return notes[position]; }
		}
		
		public override long GetItemId (int position)
		{
			return position;
		}

        public override View GetView(int position, View convertView, ViewGroup parent)
        {
            // Get our object for position
            var item = notes[position];

            //Try to reuse convertView if it's not  null, otherwise inflate it from our item layout
            // gives us some performance gains by not always inflating a new view
            // will sound familiar to MonoTouch developers with UITableViewCell.DequeueReusableCell()
            var view = (convertView ??
                    context.LayoutInflater.Inflate(
                    Resource.Layout.NoteListItem,
                    parent,
                    false)) as LinearLayout;

            // Find references to each subview in the list item's view
            var txtName = view.FindViewById<TextView>(Resource.Id.tvNoteTitle);
            var txtDate = view.FindViewById<TextView>(Resource.Id.tvNoteDate);
            var txtDescription = view.FindViewById<TextView>(Resource.Id.tvNoteText);

            //Assign item's values to the various subviews
            txtName.SetText(item.NoteTitle, TextView.BufferType.Normal);
            txtDate.SetText(item.NoteDate.ToShortDateString(), TextView.BufferType.Normal);
            txtDescription.SetText(item.NoteText, TextView.BufferType.Normal);

            //Finally return the view
            return view;
        }

        public override int Count
		{
			get { return notes.Count; }
		}

    }
}