﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using notes.WindowsPhone8.Resources;

using notes.Core;
using notes.WindowsPhone8.ViewModels;

namespace notes.WindowsPhone8
{
    public partial class DetailsPage : PhoneApplicationPage
    {
        private int index = -1;
        private NoteViewModel model;

        // Constructor
        public DetailsPage()
        {
            InitializeComponent();

            // Sample code to localize the ApplicationBar
            BuildLocalizedApplicationBar();
        }

        // When page is navigated to set data context to selected item in list
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            if (ContentPanel.DataContext == null)
            {
                string selectedIndex = "";
                if (NavigationContext.QueryString.TryGetValue("selectedItem", out selectedIndex))
                {
                    index = int.Parse(selectedIndex);

                    model = App.ViewModel.Items.First(n => n.NoteId == index);

                    EditNote.Text = AppResources.EditNote;
                }
                else
                {
                    model = new NoteViewModel();
                    EditNote.Text = AppResources.AddNote;
                }

                ContentPanel.DataContext = model;
            }
        }

        private void Save_Click(object sender, EventArgs e)
        {
            NoteManager.SaveNote(model.note);

            if (index < 0 )
                App.ViewModel.Items.Add(model);

            NavigationService.GoBack();
        }

        private void Cancel_Click(object sender, EventArgs e)
        {
            NavigationService.GoBack();
        }

        private void BuildLocalizedApplicationBar()
        {
            ApplicationBar = new ApplicationBar();

            ApplicationBarIconButton appBarButton = new ApplicationBarIconButton(new Uri("/Images/save.png", UriKind.Relative));
            appBarButton.Text = AppResources.Save;
            appBarButton.Click += Save_Click;
            ApplicationBar.Buttons.Add(appBarButton);

            appBarButton = new ApplicationBarIconButton(new Uri("/Images/cancel.png", UriKind.Relative));
            appBarButton.Text = AppResources.Cancel;
            appBarButton.Click += Cancel_Click;
            ApplicationBar.Buttons.Add(appBarButton);
        }
    }
}