﻿using System;
using System.ComponentModel;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using notes.Core;

namespace notes.WindowsPhone8.ViewModels
{
    public class NoteViewModel : INotifyPropertyChanged
    {
        public Note note = new Note();

        public int NoteId
        {
            get
            {
                return note.NoteId;
            }
            set
            {
                if (value != note.NoteId)
                {
                    note.NoteId = value;
                    NotifyPropertyChanged("NoteID");
                }
            }
        }

        public string NoteTitle
        {
            get
            {
                return note.NoteTitle;
            }
            set
            {
                if (value != note.NoteTitle)
                {
                    note.NoteTitle = value;
                    NotifyPropertyChanged("NoteTitle");
                }
            }
        }

        public DateTime NoteDate
        {
            get
            {
                return note.NoteDate;
            }
            set
            {
                if (value != note.NoteDate)
                {
                    note.NoteDate = value;
                    NotifyPropertyChanged("NoteDate");
                }
            }
        }

        public string NoteText
        {
            get
            {
                return note.NoteText;
            }
            set
            {
                if (value != note.NoteText)
                {
                    note.NoteText = value;
                    NotifyPropertyChanged("NoteText");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        private void NotifyPropertyChanged(String propertyName)
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if (null != handler)
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }
/*
        public void Assign(Note note)
        {
            this.note = note;
        }

        public NoteViewModel(Note note)
        {
            Assign(note);
        }
*/
    }
}
